/*
  $Id: XMLGenFactory.java,v 1.1 2000/09/07 15:39:08 alph Exp $ 

  GNUJSP - a free JSP implementation
  Copyright (C) 2000, Carsten Heyl <alph@gjt.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, =
  USA.
*/

package org.gjt.jsp.xml;

import java.io.Writer;
import java.io.BufferedWriter;
import java.io.IOException;

/**
 *
 * An abstract support class to encapsulate generation of xml files
 * from gnujsp internal data structure.
 * Using this base class in JspServlet avoids dependancies on apache
 * xml xlasses on servlet startup time.
 *
 */

public abstract class XMLGenFactory
{
    public XMLGenFactory() {}
    abstract public BufferedWriter createXMLWriter(Writer w);
    /**
     * generate factory class from classname
     */ 
    public static XMLGenFactory getFactoryClass(String classname) 
	throws IOException
    {
	try {
	    Class clas = Class.forName(classname);
	    return (XMLGenFactory) clas.newInstance();
	} catch(ClassNotFoundException e) {
	    throw new IOException(e.toString());
	} catch(InstantiationException e) {
	    throw new IOException(e.toString());
	} catch(IllegalAccessException e) {
	    throw new IOException(e.toString());
	}
    }
}
